#ifndef MODULE
#include <stdio.h>
#endif

#include "label.h"

_Label sLabel[MAXLABEL];

int TotalLabel=0;

/* Init label*/
void InitLabel()
{
 int i;
 TotalLabel=0;
 for(i=0;i<MAXLABEL;i++) sLabel[i].Addr = 80000;
}


/* Fidn label by ADDR -> Return _Label PTR if found, else NULL*/
_Label *FindAddrLabel(word Addr)
{
 int i;
 for(i=0;i<TotalLabel;i++) if (sLabel[i].Addr == Addr) return &sLabel[i];
 return NULL;
}

/* Fidn label by Name -> Return _Label PTR if found, else NULL*/
_Label *FindNameLabel(char *Name)
{
 int i,l=_strlen(Name);
 for(i=0;i<TotalLabel;i++) if (_strncmp(sLabel[i].Name,Name,l) == 0) return &sLabel[i];
 return NULL;
}

// Add New Label, if error return 0
int AddLabel(word Addr,char *Name)
{
 _Label *L;
 int i;

 if ((L=FindNameLabel(Name))) {return 0;}//L.Addr=Addr);return 1;} ; // Already Exist
 if ((L=FindAddrLabel(Addr))) {return 0;}//strcpy(L.Name,Name);return 1;} ; // Already Exist

 if (TotalLabel<MAXLABEL) // New Label
   {
    for (i=TotalLabel;i>0;i--)  // Insert Nel Label
      if (sLabel[i].Addr > Addr) sLabel[i+1]=sLabel[i];
      else break;

           sLabel[TotalLabel].Addr=Addr;
           sLabel[TotalLabel].Page=0;
    _strcpy(sLabel[TotalLabel].Name,Name);
    TotalLabel++;
    return 1;
   }
 return 0;
}

// Delete Label, if Error return 0
int DeleteLabel(word Addr)
{
 _Label *L;
 int i;

 if (!(L=FindAddrLabel(Addr))) return 0;        // No Label
 for (i=0;i<TotalLabel;i++) if (sLabel[i].Addr == Addr) break;
 for (;i<TotalLabel;i++) sLabel[i]=sLabel[i+1];
 TotalLabel--;
 return 1;
}



