/**************************************************************************

                           TAP Loader

**************************************************************************/

#include "emudata.h"

EmuData *TblData;
unsigned Id;

char _DSC[]="DBG Preview by ESL"; // ᠭ

// ப  䥩
char TxtOk[]="OK";
char TxtCancel[]="Cancel";
char TxtBrowse[]="Browse";

unsigned Key=0x4;



char TxtKey[]="Key:\nF7\nF8\nF9\nF10\nF11\nF12";
static const char *CKey[]={"F7","F8","F9","F10","F11","F12"};
struct CnTbl CgKey={&Key,CKey,sizeof CKey/sizeof(char*)};

//  䨣樨
static struct CfgS Cfg[]={
    TTbl,"ESL_DBG_Key=",&CgKey,
};

struct CfgDat _CFG={Cfg,sizeof Cfg/sizeof(CfgS)}; //   䨣樨


//    ⭠ 祭
static const char SymHex[]={
	'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'
};

// ॢ 祭  ப
static void HexToStr(unsigned Val,char *Txt,int Num) {
	Txt+=Num-1;
	while (Num--) {
		*Txt--=SymHex[Val&0xF];
		Val>>=4;
	}
};

void _SET() {

    void *Pnt=TblData->WinCreate(29,4,22,17,0x9F);
    TblData->WinTitle(Pnt,_DSC,0xFC);
    TblData->WinText(Pnt,3,2,"ESL, Kharkov 1998");
    TblData->SetRadio(Pnt,8,4,TxtKey,&CgKey);
    TblData->SetButton(Pnt,5,14,TxtCancel,12,0);
    TblData->SetButton(Pnt,5,12,TxtOk,12,1);
	if (TblData->WinExe(Pnt)) TblData->WinResult(Pnt);
	TblData->WinRemove(Pnt);

}

#include "main.c"

static void WorkMenu() {

char buf[5]="0000";
int c;

    TblData->TextMode();
    ClearScreen();
    CopyCPUData();
/*
    InitLabel();
    AddLabel(0x5c08,"Label2");
    AddLabel(RR.pc,"Label1");
    AddLabel(RR.hl+16,"Label3");
    AddLabel(0x5c41,"Label4");
*/
    Dmain(cMENU);

//    TblData->MessageBox(0x0f,"DEMO:",buf);
    TblData->SetSpec();
}


void _INI(EmuData *Pnt,unsigned IdN) {

	TblData=Pnt;
	Id=IdN;
}

void _UNI() {
  if (TraceCPU) TblData->CPUTraceOff(Id);
}

// 祭 ஢
//void _ON_() {/*if (TraceCPU) TblData->CPUTraceOn(Id);*/}

// 몫祭 ஢
//void _OFF() {if (TraceCPU) TblData->CPUTraceOff(Id);}


// ஢ 
unsigned RegEDI();
#pragma aux RegEDI="" value [edi]

unsigned RegESI();
#pragma aux RegESI="" value [esi]

unsigned RegEDX();
#pragma aux RegEDX="" value [edx]

unsigned RegECX();
#pragma aux RegECX="" value [ecx]

unsigned _CPU(unsigned Code) {
	unsigned RegPCr,RegSPr,RegAFr,RegFRr;
	RegPCr=RegEDI();
	RegSPr=RegESI();
	RegAFr=RegEDX();
	RegFRr=RegECX();

  if ( !TraceCPU ) return Code;

//  if ( TblData->DataCPU.IFF2 == 0 )  return Code; // in INT?

  TblData->DataCPU.IFF2=0;
  TblData->DataCPU.IFF1=0;
  TblData->TextMode();

  CopyCPUData();
  RR.pc=RegPCr;
  RR.sp=RegSPr;
  RR.af=RegAFr;
  RR.r=RegFRr & 0x7f;
//  RR.r=(RR.r & 0x80) | (RegFRr & 0x7f);

  Dmain(cTRACE);
  if (!TraceCPU) TblData->SetSpec();

  return Code;
}



void _F7_() {if (Key==0) WorkMenu();}
void _F8_() {if (Key==1) WorkMenu();}
void _F9_() {if (Key==2) WorkMenu();}
void _F10() {if (Key==3) WorkMenu();}
void _F11() {if (Key==4) WorkMenu();}
void _F12() {if (Key==5) WorkMenu();}

