#include "my.h"

extern CBreak;
extern CBorder;
extern CList;
extern CList1;
extern CList2;
extern word AddrLIST;
extern MODE;

#ifndef MODULE
extern _CPUReg RR;
#endif

extern int TraceCPU;

int SY=0,LY=0;

int XSize[8]={7, 2, 4, 2, 2, 2, 2,24};
int XPos [8]={6,13,16,22,25,28,31,35};

int CmdLEN;

int X=7;

void PutBreak(word Addr,int y)
{
 ScreenPutString("    ",CBreak,0,y+2);
 ScreenPutString("",CBorder,5,y+2);
}

void UpdateLIST(void)
{
 word addr=AddrLIST;
 int Y=0,i,len;
 char str[128];

 while (Y<14)
 {
  PutBreak(addr,Y);
  len=ScrDASM(str,addr);
//  ScreenPutString(str,((MODE == mLIST)&&(SY==Y))?CList1:CList,6,Y+2);
  ScreenPutString(str,(addr==RR.pc)?CList2:CList,6,Y+2);
//  ScreenPutString(str,CList,6,Y+2);
  ScreenPutString("",CBorder,59,Y+2);
  addr+=len;
  Y++;
 }
}

word CalcYAddr(word ADDR,int Y)
{
 char tmp[128];
 word a;

 if (Y) while (Y--) ADDR+=DASM(tmp,ADDR);
 return ADDR;
}


void LCsrUP()
{
 int i,j;
 char tmp[128];

 if (SY) SY--;
 else
   {
    j=4;
    while ( j && (DASM(tmp,AddrLIST-j)!=j) )j--;
    if (!j) j=1;
    AddrLIST-=j;
   }
}
void LCsrDown()
{
 char tmp[128];
 if (SY<13) SY++; else AddrLIST+=DASM(tmp,AddrLIST);
}

void doLIST()
{
 int i,j;
 char tmp[128];
 int  update=1;
 word ScrAddr;
 int  CmdLen;
 word ea;
 int  byt;

 for (;;)
 {
  if (update) UpdateScreen(); else UpdateLIST();
  update=0;

  ScrAddr=CalcYAddr(AddrLIST,SY);
  CmdLen=ScrDASM(tmp,ScrAddr);
  if ( ((X>=3) && (X<=6)) && (CmdLen<=X-3)) X=CmdLen+2;
  tmp[XPos[X]-6+XSize[X]]='\0';
  ScreenPutString(tmp+XPos[X]-6,CList1,XPos[X],SY+2);
  switch (getxkey())
    {
#ifdef MODULE
     case K_F7    : {TraceCPU=1;return;}
     case K_Alt_F5: {TblData->SpecMode();TblData->TextMode();break;}
#endif

     case K_Escape: {return;}

     case K_Control_P: {AddrLIST=RR.pc;break;}
     case K_Control_S: {AddrLIST=RdZ80(RR.sp+1)<<8|RdZ80(RR.sp);break;}

     case K_Control_Right:
     case K_Control_ERight: {AddrLIST++;break;}
     case K_Control_Left:
     case K_Control_ELeft: {AddrLIST--;break;}

     case K_Right:
     case K_ERight: {if (X<7) {X++;if ( ((X>=3) && (X<7)) && (CmdLen<=X-3)) X=7;} else X=0;break;}

     case K_Left:
     case K_ELeft: {if (X) X--; else X=7;break;}

     case K_EUp:
     case K_Up:     { LCsrUP(); break;}

     case K_EDown:
     case K_Down:   { LCsrDown();break;}

     case K_EPageDown:
     case K_PageDown: {for(i=0;i<13;i++) LCsrDown();break;}

     case K_EPageUp:
     case K_PageUp: {for(i=0;i<13;i++) LCsrUP();break;}

     case K_Return:
          {
           switch (X)
             {
              case 0: {break;} // Label
              case 1: {break;} // Page
              case 2:          // Addr
                   {
                    ea=EditWORD(CalcYAddr(AddrLIST,SY),XPos[X],SY+2);
                    AddrLIST=ea;
                    for (j=i=SY,SY=0;i>0;i--) LCsrUP();
                    SY=j;
                    break;
                   }
              case 3:           // Cmd Bytes
              case 4:
              case 5:
              case 6:
                   {
                    byt=0;
                    ScrAddr=CalcYAddr(AddrLIST,SY);
                    while (byt>=0 && (X>2 && X<7))
                      {
                       byt=GetBYTE(RdZ80(ScrAddr+X-3),XPos[X],SY+2);
                       if (byt>=0)
                         {
                          WrZ80(ScrAddr+X-3,byt);
                          UpdateScreen();
                          X++;
                          CmdLen=ScrDASM(tmp,ScrAddr);
                          if (CmdLen<=X-3) X=7;
                         }
                       else
                         {
                          if (-byt == K_Left) if (X>3) {byt=0;X--;UpdateLIST();}
                         }
                      }
                      break;
                   }
              case 7: {break;} // Asm
             } // Switch X
          } // K_Return
    } // GetKey
 }
}


