;*********************************************************************
;
;প Cache RAM (zx-lprint III)
;
;*********************************************************************

IDEAL
P386
MODEL USE32 SMALL
ASSUME cs:@code,ds:@data,es:@data
INCLUDE "EMUDATA.INC"

DATASEG

LABEL _DSC BYTE ;ᠭ
        DB "Pentagon Cache RAM by ESL v0.02",0

;ப  䥩
;TxtTitle        DB 1,"Cache RAM",0
;TxtOn           DB "On",0
;TxtOk           DB 1,"OK",0
;TxtCancel       DB "",1,"⬥",0

UDATASEG
TblData         DD ?    ; ⠡  
CacheON         DB ?    ; 祭 Cache
C_Page          DB ?    ;࠭  

CODESEG

;樠 (࠭   )
PROC _INI
        mov     [TblData],eax
        mov     [C_Page],030h
	ret
ENDP

;Reset (⠭ 㫥 祭 )
PROC _RES
        mov     [CacheON],0h
	ret
ENDP

;⥭  
PROC _IN_
;        cmp     bx,0Fbh
;        cmp     bl,0Fbh
        cmp     bl,080h
        jz      @@C_On
;        cmp     bx,07bh
;        cmp     bl,07bh
        cmp     bl,00h
        jnz     @@Ret

        mov     [CacheON],0
        jmp     _MEM
@@C_On:
        mov     [CacheON],1

;⠭ ᥣ⮢ 
_MEM:
        mov     ebx,[TblData]
        cmp     [CacheON],1
        jz      @@On2

        xor     eax,eax
        mov     al,[ebx+EmuData.Port7FFD]
        and     al,10h
        shl     eax,10
        add     eax,[ebx+EmuData.SpecROM]
        jmp     @@Wr
@@On2:
        xor     eax,eax
        mov     al,[C_Page]
        shl     eax,0eh
        add     eax,[ebx+EmuData.SpecRAM]
@@Wr:
        mov     [ebx+EmuData.SpecSeg],eax
	mov	ah,001h
@@Ret:	ret
ENDP

;䨣஢
UDATASEG
WinPnt		DD ? ;   
CODESEG

;PROC _SET
;        push    ebp
;
;; 
;        mov     ebp,[TblData]
;        MWinCreate ebp,016h,005h,01Fh,00Bh,01Fh
;        mov     [WinPnt],eax

;⠭  
;        MWinTitle ebp,eax,<OFFSET TxtTitle>,0F0h

;⠭ ४⥫ "ꥬ"
;        MSetRadio ebp,[WinPnt],006h,002h,<OFFSET TxtMem>,<OFFSET CfgMem>

;⠭  "⬥"
;        MSetButton ebp,[WinPnt],011h,008h,00Ah,<OFFSET TxtCancel>,0

;⠭  "OK"
;        MSetButton ebp,[WinPnt],004h,008h,00Ah,<OFFSET TxtOk>,1

;ࠡ⪠ 
;        MWinExe ebp,[WinPnt]

;஢ઠ १ 
;        test    eax,eax
;        jz      @@Exit

;࠭ ⠭ 
;        MWinResult ebp,[WinPnt]

; 
;@@Exit: MWinRemove ebp,[WinPnt]

;        pop     ebp
;        ret

ENDP

END
